function A = CalAff(TrainData,k1,k2)
% calculate the affinity matrix A
%TrainData - train data and label
%k1 - Number of neighbors considered for the within similarity graph.
%k2 - Number of neighbors considered for the between similarity graph.


N=length(TrainData.y);
Ww = zeros(N);
Wb = zeros(N);
label = TrainData.y;
for tmpC1=1:N
    l_i=TrainData.y(tmpC1);
    tmpDistanceW=TrainData.X(TrainData.y==l_i,tmpC1);
    sorted_valW=sort(tmpDistanceW,'ascend');
    tmpDistanceB=TrainData.X(TrainData.y~=l_i,tmpC1);
    sorted_valB=sort(tmpDistanceB,'ascend');
    for tmpC2=1:N
        l_j=TrainData.y(tmpC2);
        
        if(tmpC1==tmpC2)
            continue;
        end
        
        %Within graph
        if (l_i==l_j)
            len = length(find(label==l_i));
            if (TrainData.X(tmpC1,tmpC2)<=sorted_valW(min(len,k1)))
                Ww(tmpC1,tmpC2)=1;
                Ww(tmpC2,tmpC1)=1;
            end
        else
            %Between graph
            if (TrainData.X(tmpC1,tmpC2)<=sorted_valB(k2))
                Wb(tmpC1,tmpC2)=1;
                Wb(tmpC2,tmpC1)=1;
            end
        end
    end
end
A = Ww - Wb;



